'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _slicedToArray2 = require('babel-runtime/helpers/slicedToArray');

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

var _typeof2 = require('babel-runtime/helpers/typeof');

var _typeof3 = _interopRequireDefault(_typeof2);

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _assign = require('babel-runtime/core-js/object/assign');

var _assign2 = _interopRequireDefault(_assign);

var _keys = require('babel-runtime/core-js/object/keys');

var _keys2 = _interopRequireDefault(_keys);

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

exports.default = initAppManager;

var _slotFinder = require('slot-finder');

var _slotFinder2 = _interopRequireDefault(_slotFinder);

var _qs = require('qs');

var _qs2 = _interopRequireDefault(_qs);

var _path = require('./utils/path');

var _timers = require('./utils/timers');

var _appManagerError = require('./utils/app-manager-error');

var _appManagerError2 = _interopRequireDefault(_appManagerError);

var _constants = require('./constants');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function initAppManager(w) {
  var _class, _temp, _initialiseProps;

  return _temp = _class = function () {
    (0, _createClass3.default)(AppManager, null, [{
      key: '_getBrowserPath',
      value: function _getBrowserPath() {
        var source = 'get_browser_path';
        var path = w.location.pathname;

        if (!path || typeof path !== 'string') {
          throw new _appManagerError2.default('Could not get path from browser.', {
            source: source,
            code: 'no_path',
            recoverable: true
          });
        }

        return path;
      }
    }, {
      key: '_getQuery',
      value: function _getQuery() {
        return _qs2.default.parse(w.location.search, { ignoreQueryPrefix: true });
      }
    }, {
      key: '_querySelector',
      value: function _querySelector(querySelector) {
        return w.document.querySelector(querySelector);
      }
    }]);

    function AppManager(config, events) {
      var options = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
      (0, _classCallCheck3.default)(this, AppManager);

      _initialiseProps.call(this);

      var source = 'constructor';

      if (!config) {
        throw new _appManagerError2.default('Config not specified. Aborting.', {
          source: source,
          code: 'invalid_config',
          recoverable: false,
          path: AppManager._getBrowserPath()
        });
      }

      if (!w.document || !w.location || !w.history) {
        throw new _appManagerError2.default('Invalid window object. Aborting.', {
          source: source,
          code: 'invalid_environment',
          recoverable: false,
          path: AppManager._getBrowserPath()
        });
      }

      var apps = config.apps,
          slots = config.slots,
          fragments = config.fragments;


      this._apps = apps;
      this._slots = slots;
      this._fragments = fragments;
      this._events = events;
      this._options = options;
      this._evaluatedPaths = (0, _path.evaluatePaths)(this._apps);
    }

    (0, _createClass3.default)(AppManager, [{
      key: '_shimHistory',
      value: function _shimHistory() {
        var _this = this;

        /* eslint-disable no-param-reassign */

        var onpopstate = w.onpopstate,
            onbeforeunload = w.onbeforeunload;
        var _w$history = w.history,
            pushState = _w$history.pushState,
            replaceState = _w$history.replaceState;


        w.history.pushState = function () {
          for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
            args[_key] = arguments[_key];
          }

          if (typeof pushState === 'function') {
            pushState.apply(w.history, args);
          }

          _this.emit(_constants.eventTitles.HISTORY_PUSH_STATE);
          _this.emit(_constants.eventTitles.HISTORY_STATE_CHANGE, _constants.eventTitles.HISTORY_PUSH_STATE);
        };

        w.history.replaceState = function () {
          for (var _len2 = arguments.length, args = Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
            args[_key2] = arguments[_key2];
          }

          if (typeof replaceState === 'function') {
            replaceState.apply(w.history, args);
          }

          _this.emit(_constants.eventTitles.HISTORY_REPLACE_STATE);
          _this.emit(_constants.eventTitles.HISTORY_STATE_CHANGE, _constants.eventTitles.HISTORY_REPLACE_STATE);
        };

        // $FlowFixMe
        w.history.getState = function () {
          return {
            data: w.history.state,
            title: w.document.title,
            url: w.location.href,
            hash: '' + w.location.pathname + (w.location.search || '')
          };
        };

        w.onpopstate = function () {
          for (var _len3 = arguments.length, args = Array(_len3), _key3 = 0; _key3 < _len3; _key3++) {
            args[_key3] = arguments[_key3];
          }

          if (typeof onpopstate === 'function') {
            onpopstate.apply(w.history, args);
          }

          _this.emit(_constants.eventTitles.HISTORY_POP_STATE);
          _this.emit(_constants.eventTitles.HISTORY_STATE_CHANGE, _constants.eventTitles.HISTORY_POP_STATE);
        };

        w.onbeforeunload = function () {
          for (var _len4 = arguments.length, args = Array(_len4), _key4 = 0; _key4 < _len4; _key4++) {
            args[_key4] = arguments[_key4];
          }

          if (typeof onbeforeunload === 'function') {
            onbeforeunload.apply(w.history, args);
          }

          _this.removeListener(_this.constructor.eventTitles.HISTORY_STATE_CHANGE, _this._handleStateChange);

          w.onpopstate = onpopstate;
          w.history.pushState = pushState;
          w.history.replaceState = replaceState;
        };

        this.on(this.constructor.eventTitles.HISTORY_STATE_CHANGE, this._handleStateChange);
      }
    }]);
    return AppManager;
  }(), _class.statuses = _constants.statuses, _class.eventTitles = _constants.eventTitles, _class.levels = _constants.levels, _initialiseProps = function _initialiseProps() {
    var _this2 = this;

    this._status = this.constructor.statuses.UNINITIALISED;
    this._currentAppName = null;
    this._resolvedFragments = {};

    this.emit = function (eventTitle, data) {
      if (_this2._events && typeof _this2._events.emit === 'function') {
        _this2._events.emit(eventTitle, data);
      }
    };

    this.on = function (eventTitle, listener) {
      if (_this2._events && typeof _this2._events.on === 'function') {
        _this2._events.on(eventTitle, listener);
      }
    };

    this.removeListener = function (eventTitle, listener) {
      if (_this2._events && typeof _this2._events.removeListener === 'function') {
        _this2._events.removeListener(eventTitle, listener);
      }
    };

    this._updateStatus = function (statusDetails) {
      _this2._status = statusDetails.status;
      _this2.emit(_this2.constructor.eventTitles.STATUS_CHANGE, statusDetails);
    };

    this._getAppNameFromPath = function () {
      var path = _this2.constructor._getBrowserPath();

      return (0, _path.getAppNameFromPath)(_this2._evaluatedPaths, path);
    };

    this._onError = function (err) {
      _this2.emit(_this2.constructor.eventTitles.ERROR, err);

      _this2._updateStatus({
        status: _this2.constructor.statuses.ERROR,
        level: err.level || _this2.constructor.levels.ERROR,
        source: err.source,
        path: err.path,
        message: err.message
      });
    };

    this._externalLink = function (source) {
      _this2.emit(_this2.constructor.eventTitles.EXTERNAL_LINK);

      _this2._updateStatus({
        level: _this2.constructor.levels.INFO,
        status: _this2.constructor.statuses.DEFAULT,
        source: source,
        path: _this2.constructor._getBrowserPath()
      });
    };

    this._getPathParams = function (appName) {
      var source = 'get_path_params';
      var path = _this2.constructor._getBrowserPath();

      var evaluatedPath = _this2._evaluatedPaths[appName];

      var params = (0, _path.evalPathParams)(evaluatedPath, path);

      if (!params) {
        throw new _appManagerError2.default('Browser path does not match current app.', {
          source: source,
          recoverable: true,
          code: 'invalid_path'
        });
      }

      return params;
    };

    this._getSlotElement = function () {
      var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(slot) {
        var source, querySelector, element;
        return _regenerator2.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                source = 'get_slot_element';
                querySelector = slot.querySelector;

                if (querySelector) {
                  _context.next = 4;
                  break;
                }

                return _context.abrupt('return', null);

              case 4:
                _context.next = 6;
                return (0, _timers.retry)(function () {
                  return _this2.constructor._querySelector(querySelector);
                }, _constants.DOM_CHECK_INTERVAL, _this2._options.importTimeout);

              case 6:
                element = _context.sent;

                if (element) {
                  _context.next = 9;
                  break;
                }

                throw new _appManagerError2.default('Element ' + querySelector + ' not found for slot ' + slot.name + '.', {
                  source: source,
                  code: 'element_not_found',
                  recoverable: true,
                  id: slot.name
                });

              case 9:
                return _context.abrupt('return', element);

              case 10:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, _this2);
      }));

      return function (_x2) {
        return _ref.apply(this, arguments);
      };
    }();

    this._loadFragmentScript = function () {
      var _ref2 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2(fragmentName, state) {
        var source, fragment, script;
        return _regenerator2.default.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                source = 'load_fragment_script';
                fragment = _this2._fragments[fragmentName];

                if (fragment) {
                  _context2.next = 4;
                  break;
                }

                throw new _appManagerError2.default('Tried to load invalid fragment ' + fragmentName + '.', {
                  source: source,
                  code: 'fragment_not_found',
                  recoverable: false,
                  id: fragmentName
                });

              case 4:
                if (!(typeof fragment.loadScript !== 'function')) {
                  _context2.next = 6;
                  break;
                }

                throw new _appManagerError2.default('Fragment ' + fragmentName + ' does not have a loadScript function.', {
                  source: source,
                  code: 'invalid_fragment',
                  recoverable: false,
                  id: fragmentName
                });

              case 6:
                script = void 0;
                _context2.prev = 7;
                _context2.next = 10;
                return _promise2.default.race([fragment.loadScript(state), (0, _timers.delay)(_this2._options.importTimeout)]);

              case 10:
                script = _context2.sent;
                _context2.next = 16;
                break;

              case 13:
                _context2.prev = 13;
                _context2.t0 = _context2['catch'](7);
                throw new _appManagerError2.default(_context2.t0, {
                  source: source,
                  code: 'load_script',
                  recoverable: true,
                  id: fragmentName
                });

              case 16:
                if (script) {
                  _context2.next = 18;
                  break;
                }

                throw new _appManagerError2.default('loadScript timed out for fragment ' + fragmentName + '.', {
                  source: source,
                  code: 'time_out',
                  recoverable: true,
                  id: fragmentName
                });

              case 18:
                if ('version' in script) {
                  _context2.next = 20;
                  break;
                }

                throw new _appManagerError2.default('Loaded script for fragment ' + fragmentName + ' does not have a version property.', {
                  source: source,
                  code: 'invalid_script',
                  recoverable: false,
                  id: fragmentName
                });

              case 20:
                return _context2.abrupt('return', script);

              case 21:
              case 'end':
                return _context2.stop();
            }
          }
        }, _callee2, _this2, [[7, 13]]);
      }));

      return function (_x3, _x4) {
        return _ref2.apply(this, arguments);
      };
    }();

    this._resolveFragment = function () {
      var _ref3 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee3(slotName, fragmentName, state) {
        var script, resolvedFragment;
        return _regenerator2.default.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                if (!_this2._resolvedFragments[fragmentName]) {
                  _context3.next = 2;
                  break;
                }

                return _context3.abrupt('return', _this2._resolvedFragments[fragmentName]);

              case 2:
                _context3.next = 4;
                return _this2._loadFragmentScript(fragmentName, state);

              case 4:
                script = _context3.sent;
                resolvedFragment = { script: script, slot: slotName, name: fragmentName };


                _this2._resolvedFragments[fragmentName] = resolvedFragment;

                return _context3.abrupt('return', resolvedFragment);

              case 8:
              case 'end':
                return _context3.stop();
            }
          }
        }, _callee3, _this2);
      }));

      return function (_x5, _x6, _x7) {
        return _ref3.apply(this, arguments);
      };
    }();

    this._findPageFragments = function (appName) {
      var source = 'find_page_fragments';
      var app = _this2._apps[appName];

      if (!Array.isArray(app.fragments)) {
        throw new _appManagerError2.default('App ' + appName + ' does not have a fragments array', {
          source: source,
          code: 'invalid_app',
          recoverable: false,
          id: appName
        });
      }

      var appFragments = app.fragments.map(function (fragmentName) {
        return _this2._fragments[fragmentName];
      });

      var emptySlots = (0, _keys2.default)(_this2._slots).reduce(function (empty, slotName) {
        return (0, _assign2.default)(empty, (0, _defineProperty3.default)({}, slotName, null));
      }, {});

      var pageFragments = void 0;

      try {
        pageFragments = (0, _slotFinder2.default)(emptySlots, appFragments);
      } catch (err) {
        throw new _appManagerError2.default(err, {
          source: source,
          code: 'slot_finder',
          recoverable: true,
          id: appName
        });
      }

      if (!pageFragments || (typeof pageFragments === 'undefined' ? 'undefined' : (0, _typeof3.default)(pageFragments)) !== 'object') {
        throw new _appManagerError2.default('SlotFinder returned invalid fragments for app ' + appName, {
          source: source,
          code: 'get_fragments',
          recoverable: false,
          id: appName
        });
      }

      return pageFragments;
    };

    this._resolvePageFragments = function () {
      var _ref4 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee4(pageFragments, state) {
        var resolveFragmentPromises;
        return _regenerator2.default.wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                resolveFragmentPromises = (0, _keys2.default)(pageFragments).filter(function (slotName) {
                  var fragmentName = pageFragments[slotName];
                  return fragmentName && _this2._fragments[fragmentName].managed;
                }).map(function (slotName) {
                  return _this2._resolveFragment(slotName, pageFragments[slotName], state);
                });
                return _context4.abrupt('return', _promise2.default.all(resolveFragmentPromises));

              case 2:
              case 'end':
                return _context4.stop();
            }
          }
        }, _callee4, _this2);
      }));

      return function (_x8, _x9) {
        return _ref4.apply(this, arguments);
      };
    }();

    this._getState = function (appName) {
      var eventTitle = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
      return {
        event: eventTitle,
        path: _this2.constructor._getBrowserPath(),
        params: _this2._getPathParams(appName),
        query: _this2.constructor._getQuery(),
        prevApp: _this2._currentAppName ? _this2._apps[_this2._currentAppName] : null,
        app: _this2._apps[appName]
      };
    };

    this._hydrate = function (state) {
      return function () {
        var _ref5 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee5(resolvedFragment) {
          var source, script, name, slotName, appName, slot, slotElement, app;
          return _regenerator2.default.wrap(function _callee5$(_context5) {
            while (1) {
              switch (_context5.prev = _context5.next) {
                case 0:
                  source = 'hydrate';
                  script = resolvedFragment.script, name = resolvedFragment.name, slotName = resolvedFragment.slot;
                  appName = state.app.name;
                  slot = _this2._slots[slotName];

                  if (slot) {
                    _context5.next = 6;
                    break;
                  }

                  throw new _appManagerError2.default('Fragment ' + name + ' tried to mount into non-existent slot ' + slot, {
                    source: source,
                    code: 'invalid_slot',
                    recoverable: false,
                    id: name
                  });

                case 6:
                  _context5.next = 8;
                  return _this2._getSlotElement(slot);

                case 8:
                  slotElement = _context5.sent;

                  if (slotElement) {
                    _context5.next = 11;
                    break;
                  }

                  return _context5.abrupt('return');

                case 11:
                  app = _this2._apps[appName];
                  _context5.prev = 12;

                  if (!(script.version === 3)) {
                    _context5.next = 18;
                    break;
                  }

                  _context5.next = 16;
                  return script.hydrate(slotElement, w.history, app);

                case 16:
                  _context5.next = 36;
                  break;

                case 18:
                  if (!(script.version === 4)) {
                    _context5.next = 28;
                    break;
                  }

                  if (!(typeof script.hydrate === 'function')) {
                    _context5.next = 24;
                    break;
                  }

                  _context5.next = 22;
                  return script.hydrate(slotElement, app);

                case 22:
                  _context5.next = 26;
                  break;

                case 24:
                  _context5.next = 26;
                  return script.mount(slotElement, _constants.eventTitles.HISTORY_REPLACE_STATE, app);

                case 26:
                  _context5.next = 36;
                  break;

                case 28:
                  if (!(typeof script.hydrate === 'function')) {
                    _context5.next = 33;
                    break;
                  }

                  _context5.next = 31;
                  return script.hydrate(slotElement, state);

                case 31:
                  _context5.next = 36;
                  break;

                case 33:
                  if (!(typeof script.render === 'function')) {
                    _context5.next = 36;
                    break;
                  }

                  _context5.next = 36;
                  return script.render(slotElement, state);

                case 36:
                  _context5.next = 41;
                  break;

                case 38:
                  _context5.prev = 38;
                  _context5.t0 = _context5['catch'](12);
                  throw new _appManagerError2.default(_context5.t0, {
                    source: source,
                    code: 'hydrate',
                    recoverable: true,
                    id: name
                  });

                case 41:
                case 'end':
                  return _context5.stop();
              }
            }
          }, _callee5, _this2, [[12, 38]]);
        }));

        return function (_x11) {
          return _ref5.apply(this, arguments);
        };
      }();
    };

    this._unmount = function (state) {
      return function () {
        var _ref6 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee6(resolvedFragment) {
          var source, script, name, slotName, slot, slotElement, oldAppName, oldApp;
          return _regenerator2.default.wrap(function _callee6$(_context6) {
            while (1) {
              switch (_context6.prev = _context6.next) {
                case 0:
                  source = 'unmount';
                  script = resolvedFragment.script, name = resolvedFragment.name, slotName = resolvedFragment.slot;
                  slot = _this2._slots[slotName];

                  if (slot) {
                    _context6.next = 5;
                    break;
                  }

                  throw new _appManagerError2.default('Fragment ' + name + ' tried to unmount from non-existent slot ' + slot, {
                    source: source,
                    code: 'invalid_slot',
                    recoverable: false,
                    id: name
                  });

                case 5:
                  _context6.next = 7;
                  return _this2._getSlotElement(slot);

                case 7:
                  slotElement = _context6.sent;

                  if (slotElement) {
                    _context6.next = 10;
                    break;
                  }

                  return _context6.abrupt('return');

                case 10:
                  oldAppName = state.prevApp ? state.prevApp.name : null;
                  oldApp = oldAppName ? _this2._apps[oldAppName] : null;

                  if (!(!oldApp || !state.event)) {
                    _context6.next = 14;
                    break;
                  }

                  throw new _appManagerError2.default('Invalid state passed to unmount function for fragment ' + name, {
                    source: source,
                    code: 'invalid_state',
                    recoverable: true,
                    id: name
                  });

                case 14:
                  _context6.prev = 14;

                  if (!(script.version === 3)) {
                    _context6.next = 20;
                    break;
                  }

                  _context6.next = 18;
                  return script.unmount(slotElement, w.history, oldApp);

                case 18:
                  _context6.next = 28;
                  break;

                case 20:
                  if (!(script.version === 4)) {
                    _context6.next = 25;
                    break;
                  }

                  _context6.next = 23;
                  return script.unmount(slotElement, state.event, oldApp);

                case 23:
                  _context6.next = 28;
                  break;

                case 25:
                  if (!(typeof script.unmount === 'function')) {
                    _context6.next = 28;
                    break;
                  }

                  _context6.next = 28;
                  return script.unmount(slotElement, state);

                case 28:
                  _context6.next = 33;
                  break;

                case 30:
                  _context6.prev = 30;
                  _context6.t0 = _context6['catch'](14);
                  throw new _appManagerError2.default(_context6.t0, {
                    source: source,
                    code: 'unmount',
                    recoverable: true,
                    id: name
                  });

                case 33:
                case 'end':
                  return _context6.stop();
              }
            }
          }, _callee6, _this2, [[14, 30]]);
        }));

        return function (_x12) {
          return _ref6.apply(this, arguments);
        };
      }();
    };

    this._render = function (state) {
      return function () {
        var _ref7 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee7(resolvedFragment) {
          var source, script, name, slotName, appName, slot, slotElement, app;
          return _regenerator2.default.wrap(function _callee7$(_context7) {
            while (1) {
              switch (_context7.prev = _context7.next) {
                case 0:
                  source = 'render';
                  script = resolvedFragment.script, name = resolvedFragment.name, slotName = resolvedFragment.slot;
                  appName = state.app.name;
                  slot = _this2._slots[slotName];

                  if (slot) {
                    _context7.next = 6;
                    break;
                  }

                  throw new _appManagerError2.default('Fragment ' + name + ' tried to mount into non-existent slot ' + slot, {
                    source: source,
                    code: 'invalid_slot',
                    recoverable: false,
                    id: name
                  });

                case 6:
                  _context7.next = 8;
                  return _this2._getSlotElement(slot);

                case 8:
                  slotElement = _context7.sent;

                  if (slotElement) {
                    _context7.next = 11;
                    break;
                  }

                  return _context7.abrupt('return');

                case 11:
                  app = _this2._apps[appName];
                  _context7.prev = 12;

                  if (!(script.version === 3)) {
                    _context7.next = 18;
                    break;
                  }

                  _context7.next = 16;
                  return script.mount(slotElement, w.history, app);

                case 16:
                  _context7.next = 28;
                  break;

                case 18:
                  if (!(script.version === 4)) {
                    _context7.next = 25;
                    break;
                  }

                  if (state.event) {
                    _context7.next = 21;
                    break;
                  }

                  throw new _appManagerError2.default('Invalid state passed to unmount function for fragment ' + name, {
                    source: source,
                    code: 'invalid_state',
                    recoverable: true,
                    id: name
                  });

                case 21:
                  _context7.next = 23;
                  return script.mount(slotElement, state.event, app);

                case 23:
                  _context7.next = 28;
                  break;

                case 25:
                  if (!(typeof script.render === 'function')) {
                    _context7.next = 28;
                    break;
                  }

                  _context7.next = 28;
                  return script.render(slotElement, state);

                case 28:
                  _context7.next = 33;
                  break;

                case 30:
                  _context7.prev = 30;
                  _context7.t0 = _context7['catch'](12);
                  throw new _appManagerError2.default(_context7.t0, {
                    source: source,
                    code: 'render',
                    recoverable: true,
                    id: name
                  });

                case 33:
                case 'end':
                  return _context7.stop();
              }
            }
          }, _callee7, _this2, [[12, 30]]);
        }));

        return function (_x13) {
          return _ref7.apply(this, arguments);
        };
      }();
    };

    this._onStateChange = function (state) {
      return function () {
        var _ref8 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee8(resolvedFragment) {
          var source, script, name, appName, app;
          return _regenerator2.default.wrap(function _callee8$(_context8) {
            while (1) {
              switch (_context8.prev = _context8.next) {
                case 0:
                  source = 'on_state_change';
                  script = resolvedFragment.script, name = resolvedFragment.name;
                  appName = state.app.name;
                  app = _this2._apps[appName];
                  _context8.prev = 4;

                  if (!(script.version === 3)) {
                    _context8.next = 10;
                    break;
                  }

                  _context8.next = 8;
                  return script.onStateChange(w.history, app);

                case 8:
                  _context8.next = 21;
                  break;

                case 10:
                  if (!(script.version === 4)) {
                    _context8.next = 18;
                    break;
                  }

                  if (!(typeof script.onStateChange === 'function')) {
                    _context8.next = 16;
                    break;
                  }

                  if (state.event) {
                    _context8.next = 14;
                    break;
                  }

                  throw new _appManagerError2.default('Invalid state passed to unmount function for fragment ' + name, {
                    source: source,
                    code: 'invalid_state',
                    recoverable: true,
                    id: name
                  });

                case 14:
                  _context8.next = 16;
                  return script.onStateChange(state.event, app);

                case 16:
                  _context8.next = 21;
                  break;

                case 18:
                  if (!(typeof script.onStateChange === 'function')) {
                    _context8.next = 21;
                    break;
                  }

                  _context8.next = 21;
                  return script.onStateChange(state);

                case 21:
                  _context8.next = 26;
                  break;

                case 23:
                  _context8.prev = 23;
                  _context8.t0 = _context8['catch'](4);
                  throw new _appManagerError2.default(_context8.t0, {
                    source: source,
                    code: 'on_state_change',
                    recoverable: true,
                    id: name
                  });

                case 26:
                case 'end':
                  return _context8.stop();
              }
            }
          }, _callee8, _this2, [[4, 23]]);
        }));

        return function (_x14) {
          return _ref8.apply(this, arguments);
        };
      }();
    };

    this._hydratePage = function () {
      var _ref9 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee9(state) {
        var pageFragments, resolvedFragments, hydratePromises;
        return _regenerator2.default.wrap(function _callee9$(_context9) {
          while (1) {
            switch (_context9.prev = _context9.next) {
              case 0:
                pageFragments = _this2._findPageFragments(state.app.name);
                _context9.next = 3;
                return _this2._resolvePageFragments(pageFragments, state);

              case 3:
                resolvedFragments = _context9.sent;
                hydratePromises = resolvedFragments.map(_this2._hydrate(state));
                _context9.next = 7;
                return _promise2.default.all(hydratePromises);

              case 7:
              case 'end':
                return _context9.stop();
            }
          }
        }, _callee9, _this2);
      }));

      return function (_x15) {
        return _ref9.apply(this, arguments);
      };
    }();

    this._updatePage = function () {
      var _ref10 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee10(state) {
        var source, oldAppName, newAppName, oldPageFragments, newPageFragments, _ref11, _ref12, oldResolvedFragments, newResolvedFragments, oldFragmentNames, newFragmentNames, unmountPromises, mountPromises, onStateChangePromises;

        return _regenerator2.default.wrap(function _callee10$(_context10) {
          while (1) {
            switch (_context10.prev = _context10.next) {
              case 0:
                source = 'update_page';
                oldAppName = _this2._currentAppName;
                newAppName = state.app.name;

                if (oldAppName) {
                  _context10.next = 5;
                  break;
                }

                throw new _appManagerError2.default('No old app set when trying to mount ' + newAppName, {
                  source: source,
                  code: 'no_current_app',
                  recoverable: true,
                  id: newAppName
                });

              case 5:
                oldPageFragments = _this2._findPageFragments(oldAppName);
                newPageFragments = _this2._findPageFragments(newAppName);
                _context10.next = 9;
                return _promise2.default.all([_this2._resolvePageFragments(oldPageFragments, state), _this2._resolvePageFragments(newPageFragments, state)]);

              case 9:
                _ref11 = _context10.sent;
                _ref12 = (0, _slicedToArray3.default)(_ref11, 2);
                oldResolvedFragments = _ref12[0];
                newResolvedFragments = _ref12[1];
                oldFragmentNames = oldResolvedFragments.map(function (_ref13) {
                  var name = _ref13.name;
                  return name;
                });
                newFragmentNames = newResolvedFragments.map(function (_ref14) {
                  var name = _ref14.name;
                  return name;
                });
                unmountPromises = oldResolvedFragments.filter(function (resolvedFragment) {
                  return newFragmentNames.indexOf(resolvedFragment.name) === -1;
                }).map(_this2._unmount(state));
                _context10.next = 18;
                return _promise2.default.all(unmountPromises);

              case 18:
                mountPromises = newResolvedFragments.filter(function (resolvedFragment) {
                  return oldFragmentNames.indexOf(resolvedFragment.name) === -1;
                }).map(_this2._render(state));
                _context10.next = 21;
                return _promise2.default.all(mountPromises);

              case 21:
                onStateChangePromises = oldResolvedFragments.filter(function (resolvedFragment) {
                  return newFragmentNames.indexOf(resolvedFragment.name) > -1;
                }).map(_this2._onStateChange(state));
                _context10.next = 24;
                return _promise2.default.all(onStateChangePromises);

              case 24:
              case 'end':
                return _context10.stop();
            }
          }
        }, _callee10, _this2);
      }));

      return function (_x16) {
        return _ref10.apply(this, arguments);
      };
    }();

    this._handleStateChange = function () {
      var _ref15 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee11(eventTitle) {
        var source, newAppName, state;
        return _regenerator2.default.wrap(function _callee11$(_context11) {
          while (1) {
            switch (_context11.prev = _context11.next) {
              case 0:
                source = 'handle_state_change';
                _context11.prev = 1;

                if (!(typeof eventTitle !== 'string')) {
                  _context11.next = 4;
                  break;
                }

                throw new _appManagerError2.default('Invalid eventTitle ' + String(eventTitle) + ' emitted.', {
                  source: source,
                  recoverable: true,
                  code: 'invalid_event_title'
                });

              case 4:
                if (!(_this2._status === _this2.constructor.statuses.UNINITIALISED)) {
                  _context11.next = 6;
                  break;
                }

                throw new _appManagerError2.default('Tried to update path when before initialising.', {
                  source: source,
                  recoverable: true,
                  code: 'app_not_ready'
                });

              case 6:

                _this2._updateStatus({
                  level: _this2.constructor.levels.INFO,
                  status: _this2.constructor.statuses.LOADING,
                  source: source,
                  path: _this2.constructor._getBrowserPath()
                });

                newAppName = _this2._getAppNameFromPath();

                if (newAppName) {
                  _context11.next = 11;
                  break;
                }

                _this2._externalLink(source);
                return _context11.abrupt('return');

              case 11:
                state = _this2._getState(newAppName, eventTitle);
                _context11.next = 14;
                return _this2._updatePage(state);

              case 14:

                _this2._currentAppName = newAppName;

                _this2._updateStatus({
                  level: _this2.constructor.levels.INFO,
                  status: _this2.constructor.statuses.DEFAULT,
                  source: source,
                  path: _this2.constructor._getBrowserPath()
                });

                _this2.emit(_this2.constructor.eventTitles.STATE_CHANGE_COMPLETE);
                _context11.next = 22;
                break;

              case 19:
                _context11.prev = 19;
                _context11.t0 = _context11['catch'](1);

                _this2._onError(new _appManagerError2.default(_context11.t0, {
                  level: _this2.constructor.statuses.ERROR,
                  source: source,
                  path: _this2.constructor._getBrowserPath()
                }));

              case 22:
              case 'end':
                return _context11.stop();
            }
          }
        }, _callee11, _this2, [[1, 19]]);
      }));

      return function (_x17) {
        return _ref15.apply(this, arguments);
      };
    }();

    this.init = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee12() {
      var source, currentAppName, state;
      return _regenerator2.default.wrap(function _callee12$(_context12) {
        while (1) {
          switch (_context12.prev = _context12.next) {
            case 0:
              source = 'init';
              _context12.prev = 1;

              _this2._shimHistory();

              _this2._updateStatus({
                level: _this2.constructor.levels.INFO,
                status: _this2.constructor.statuses.LOADING,
                source: source,
                path: _this2.constructor._getBrowserPath()
              });

              currentAppName = _this2._getAppNameFromPath();

              if (currentAppName) {
                _context12.next = 8;
                break;
              }

              _this2._externalLink(source);
              return _context12.abrupt('return');

            case 8:

              _this2._currentAppName = currentAppName;

              state = _this2._getState(currentAppName);
              _context12.next = 12;
              return _this2._hydratePage(state);

            case 12:

              _this2._updateStatus({
                level: _this2.constructor.levels.INFO,
                status: _this2.constructor.statuses.DEFAULT,
                source: source,
                path: _this2.constructor._getBrowserPath()
              });
              _context12.next = 18;
              break;

            case 15:
              _context12.prev = 15;
              _context12.t0 = _context12['catch'](1);

              _this2._onError(new _appManagerError2.default(_context12.t0, {
                level: _this2.constructor.levels.ERROR,
                source: source,
                path: _this2.constructor._getBrowserPath()
              }));

            case 18:
            case 'end':
              return _context12.stop();
          }
        }
      }, _callee12, _this2, [[1, 15]]);
    }));
  }, _temp;
}