'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _toConsumableArray2 = require('babel-runtime/helpers/toConsumableArray');

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _typeof2 = require('babel-runtime/helpers/typeof');

var _typeof3 = _interopRequireDefault(_typeof2);

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _assign = require('babel-runtime/core-js/object/assign');

var _assign2 = _interopRequireDefault(_assign);

var _keys = require('babel-runtime/core-js/object/keys');

var _keys2 = _interopRequireDefault(_keys);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _slotFinder = require('slot-finder');

var _slotFinder2 = _interopRequireDefault(_slotFinder);

var _qs = require('qs');

var _qs2 = _interopRequireDefault(_qs);

var _path = require('./utils/path');

var _appManagerError = require('./utils/app-manager-error');

var _appManagerError2 = _interopRequireDefault(_appManagerError);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var AppManagerServer = function AppManagerServer(config) {
  var _this = this;

  (0, _classCallCheck3.default)(this, AppManagerServer);

  this.getSlotsMarkup = function () {
    var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2(path, query) {
      for (var _len = arguments.length, getMarkupArgs = Array(_len > 2 ? _len - 2 : 0), _key = 2; _key < _len; _key++) {
        getMarkupArgs[_key - 2] = arguments[_key];
      }

      var source, currentAppName, app, appFragments, emptySlots, pageFragments, params, parsedQuery, state, getMarkupPromises, resolvedMarkup;
      return _regenerator2.default.wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              source = 'get_slots_markup';
              _context2.prev = 1;
              currentAppName = (0, _path.getAppNameFromPath)(_this._evaluatedPaths, path);

              if (currentAppName) {
                _context2.next = 5;
                break;
              }

              throw new _appManagerError2.default('Could not find a route to match path', {
                code: 'invalid_route'
              });

            case 5:
              app = _this._apps[currentAppName];

              if (Array.isArray(app.fragments)) {
                _context2.next = 8;
                break;
              }

              throw new _appManagerError2.default('App ' + currentAppName + ' does not have a fragments array', {
                code: 'invalid_app',
                id: currentAppName
              });

            case 8:
              appFragments = app.fragments.map(function (fragmentName) {
                return _this._fragments[fragmentName];
              });
              emptySlots = (0, _keys2.default)(_this._slots).reduce(function (empty, slotName) {
                return (0, _assign2.default)({}, empty, (0, _defineProperty3.default)({}, slotName, null));
              }, {});
              pageFragments = (0, _slotFinder2.default)(emptySlots, appFragments);
              params = (0, _path.evalPathParams)(_this._evaluatedPaths[currentAppName], path);

              if (params) {
                _context2.next = 14;
                break;
              }

              throw new _appManagerError2.default('Could not get params from path for app ' + currentAppName, {
                code: 'invalid_appPath',
                id: currentAppName
              });

            case 14:
              parsedQuery = (typeof query === 'undefined' ? 'undefined' : (0, _typeof3.default)(query)) === 'object' ? query : _qs2.default.parse(query);
              state = {
                event: null,
                path: path,
                params: params,
                query: parsedQuery,
                prevApp: null,
                app: _this._apps[currentAppName]
              };
              getMarkupPromises = (0, _keys2.default)(pageFragments).map(function () {
                var _ref2 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(slotName) {
                  var fragmentName, fragment, markup;
                  return _regenerator2.default.wrap(function _callee$(_context) {
                    while (1) {
                      switch (_context.prev = _context.next) {
                        case 0:
                          fragmentName = pageFragments[slotName];
                          fragment = _this._fragments[fragmentName];

                          if (!(fragment && typeof fragment.getMarkup === 'function')) {
                            _context.next = 8;
                            break;
                          }

                          _context.next = 5;
                          return fragment.getMarkup.apply(fragment, [state].concat((0, _toConsumableArray3.default)(getMarkupArgs)));

                        case 5:
                          _context.t0 = _context.sent;
                          _context.next = 9;
                          break;

                        case 8:
                          _context.t0 = '';

                        case 9:
                          markup = _context.t0;
                          return _context.abrupt('return', { slotName: slotName, markup: markup });

                        case 11:
                        case 'end':
                          return _context.stop();
                      }
                    }
                  }, _callee, _this);
                }));

                return function (_x3) {
                  return _ref2.apply(this, arguments);
                };
              }());
              _context2.next = 19;
              return _promise2.default.all(getMarkupPromises);

            case 19:
              resolvedMarkup = _context2.sent;
              return _context2.abrupt('return', resolvedMarkup.reduce(function (acc, _ref3) {
                var slotName = _ref3.slotName,
                    markup = _ref3.markup;
                return (0, _assign2.default)({}, acc, (0, _defineProperty3.default)({}, slotName, markup));
              }, {}));

            case 23:
              _context2.prev = 23;
              _context2.t0 = _context2['catch'](1);
              throw new _appManagerError2.default(_context2.t0, {
                source: source,
                path: path
              });

            case 26:
            case 'end':
              return _context2.stop();
          }
        }
      }, _callee2, _this, [[1, 23]]);
    }));

    return function (_x, _x2) {
      return _ref.apply(this, arguments);
    };
  }();

  var apps = config.apps,
      slots = config.slots,
      fragments = config.fragments;


  this._apps = apps;
  this._slots = slots;
  this._fragments = fragments;
  this._evaluatedPaths = (0, _path.evaluatePaths)(this._apps);
};

exports.default = AppManagerServer;